public class Exo4{

    // caractère à une position donnée
public static String charAtPos(String s, int i) {
	return String.valueOf(s.charAt(i));
}
// test d'égalité entre chaînes de caractères
public static boolean stringEquals(String s, String t) {
	return s.equals(t);
}

public static boolean isTernaryEncoding(String ch){
	if (ch.length()!=5){
		return false;
	}
	for (int i = 0; i < ch.length(); i++){
		if (!(charAtPos(ch,i).equals("0")||charAtPos(ch,i).equals("1")||charAtPos(ch,i).equals("2"))){
			return false;
		}
	}
	return true;
}

public static int powerThree(int n){
	int res = 1;
	for (int i = 1; i <= n; i++){
		res = res * 3;
	}
	return res;
}


public static int decode (String ch){
	if (!isTernaryEncoding(ch)){
		return -1;
	}
	int res = 0;
	for (int i = 0; i < ch.length(); i++){
		res = res + Integer.valueOf(charAtPos(ch,i))*powerThree(i);
	}
	return res;
}

public static int decodebis (String ch){
	if (!isTernaryEncoding(ch)){
		return -1;
	}
	int res = 0;
	for (int i = 0; i < ch.length(); i++){
		if (charAtPos(ch,i).equals("1")){
		res = res + 1*powerThree(i);
		}
		if (charAtPos(ch,i).equals("2")){
		res = res + 2*powerThree(i);
		}
	}
	return res;
}


public static String encode (int n){
	if (n < 0 || n >= 243){
		return "";
	}
	String res = "";
	int reste = n;
	for (int i = 0; i < 5; i++){
		res = res + String.valueOf(reste%3);
		reste = reste / 3;
	}
	return res;
}

public static void main (String[] args){
System.out.println("Exo 3.1");
System.out.println(isTernaryEncoding("10120"));
System.out.println(isTernaryEncoding("10ba0"));
System.out.println(isTernaryEncoding("102"));
System.out.println("Exo 3.2");
System.out.println(powerThree(3));
System.out.println("Exo 3.3");
System.out.println(decode("12000"));
System.out.println(decode("10001"));
System.out.println(decode("1201"));
System.out.println("Exo 3.4");
System.out.println(encode(7));
System.out.println(encode(12));	
}

}