public class Exo6{

	public static void printArray (int[] t){
		System.out.print("{");
		for (int i =0; i < t.length-1; i++){
			System.out.print(t[i]);
			System.out.print(", ");
		}
		System.out.print(t[t.length-1]);
		System.out.println("}");
	}

public static boolean isCard(int[] card){
	if (card.length != 15){
		return false;
	}
	for (int i = 0; i < card.length; i++){
		if (card[i] < 1 || card[i] > 90){
			return false;
		}
	}
	return true;
}



public static int[] mark (int[] card, int n){
	int[] res = new int[card.length];
	for (int i = 0; i < card.length; i++){
		if (card[i] != n){
			res[i]=card[i];
		}
		else{
			res[i]=0;
		}
	}
	return res;
}


public static int[] texasMark (int[] card, int n){
	int[] res = new int[card.length];
	for (int i = 0; i < card.length; i++){
		if (card[i]%2 != n%2){
			res[i]=card[i];
		}
		else{
			res[i]=0;
		}
	}
	return res;
}

public static int[] wildMark (int[] card, int n){
	int[] res = new int[card.length];
	for (int i = 0; i < card.length; i++){
		if (card[i]%10 != n%10){
			res[i]=card[i];
		}
		else{
			res[i]=0;
		}
	}
	return res;
}

public static boolean win(int[] card){
	for (int i = 0; i < card.length; i++){
		if (card[i]!=0){
			return false;
		}
	}
	return true;
}

public static boolean smallwin(int[] card, int m){
	boolean flag = false;
	for (int i =0; i < card.length-m; i++){
		flag = true;
		for (int j = 0; j < m && flag; j++){
			if (card[i+j]!=0){
				flag = false;
			}
		}
		if (flag){
			return flag;
		}	
	}
	return flag;
}

    public static void main(String[] args) {
    	System.out.println("Tests question 1 :");
    	int[] card1={18,15,1,4,15};
    	System.out.println(isCard(card1));
    	int[] card2={1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};
		System.out.println(isCard(card2));
    	int[] card3={140,2,3,4,5,6,7,8,9,10,11,12,13,14,15};
    	System.out.println(isCard(card3));
    	System.out.println("Tests question 2 :");
    	int[] card={10,2,3,4,5,6,7,8,9,10,11,12,13,14,10};
    	printArray(mark(card,10));
    	System.out.println("Tests question 3 :");
    	int[] card4={10,2,3,4,5,6,7,8,9,10,11,12,13,14,10};
    	printArray(texasMark(card4,42));
    	System.out.println("Tests question 4 :");
    	int[] card5={32,52,3,4,5,6,7,8,9,42,11,12,13,14,10};
    	printArray(wildMark(card5,2));
    	System.out.println("Tests question 5 :");
    	int[] card6={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
    	int[] card7={0,0,3,0,5,0,7,0,9,0,11,0,13,0,0};
    	System.out.println(win(card6));
    	System.out.println(win(card7));
    	System.out.println("Tests question 6 :");
    	int[] card8={0,0,3,0,5,0,7,0,9,0,11,0,13,0,0};
    	int[] card9={0,0,3,0,5,0,7,0,0,0,11,0,13,0,0};
    	System.out.println(smallwin(card8,3));
    	System.out.println(smallwin(card9,3));
    }	
}